SystemOrganization addCategory: #'Mondrian-ShapeVisitor'!

Object subclass: #ShapeVisitor
	instanceVariableNames: 'anElement aCanvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-ShapeVisitor'!

ShapeVisitor subclass: #ConcreteShapeVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-ShapeVisitor'!

!ConcreteShapeVisitor classSide methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/12/2011 13:51'!
newElement: element on:canvas
^ self new setElement: element on: canvas! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:12'!
visitArrowedDashedLineShape: anMOArrowedDashedLineShape
"Display an arrowed dashed line for the provided edge element on the canvas"
	
	| fromPoint toPoint t u vector unit arrowLeft arrowRight arrowMiddle w c |	
		
	t := anMOArrowedDashedLineShape getAttachPointsFor: anElement.
	anMOArrowedDashedLineShape towardsTo 
		ifTrue:[ fromPoint := t first.
				  toPoint := t second ]
		ifFalse:[ fromPoint := t second. 
					toPoint := t first ].
			
	"Draw head"
	vector := toPoint - fromPoint.
	u := vector normal.
	unit := vector / vector r.
	arrowMiddle := toPoint - (unit * anMOArrowedDashedLineShape arrowSize). 
	arrowLeft :=  arrowMiddle - (u * anMOArrowedDashedLineShape arrowSize).
	arrowRight := arrowMiddle + (u * anMOArrowedDashedLineShape arrowSize).

	w := anMOArrowedDashedLineShape widthFor: anElement.
	c := anMOArrowedDashedLineShape colorFor: anElement.
	aCanvas line: toPoint to: arrowLeft width: w color: c.
	aCanvas line: arrowLeft to: arrowRight width: w color: c.
	aCanvas line: arrowRight to: toPoint width: w color: c.

	"draw line"
	aCanvas line: fromPoint to: arrowMiddle width: w colors: {c. anMOArrowedDashedLineShape secondaryColor} dashes: anMOArrowedDashedLineShape dashLengths startingOffset: 0. ! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'AlexandreBergel 9/27/2012 11:47'!
visitArrowedLineShape: anMOArrowedLineShape
	"Display an arrowed straight line on a canvas"

	| fromPoint toPoint t u vector unit arrowLeft arrowRight arrowMiddle w c |	
		
	t := anMOArrowedLineShape getAttachPointsFor: anElement.
	fromPoint := t first.
	toPoint := t second.
			
	"Draw head"
	vector := toPoint - fromPoint.
	u := vector normal.
	unit := vector / vector r.
	arrowMiddle := toPoint - (unit * anMOArrowedLineShape arrowSize). 
	arrowLeft :=  arrowMiddle- (u * anMOArrowedLineShape arrowSize).
	arrowRight := arrowMiddle + (u * anMOArrowedLineShape arrowSize).

	w := anMOArrowedLineShape widthFor: anElement.
	c := anMOArrowedLineShape colorFor: anElement.
	aCanvas line: toPoint asIntegerPoint to: arrowLeft asIntegerPoint width: w color: c.
	aCanvas line: arrowLeft asIntegerPoint to: arrowRight asIntegerPoint width: w color: c.
	aCanvas line: arrowRight asIntegerPoint to: toPoint asIntegerPoint width: w color: c.

	"draw line"
	aCanvas line: fromPoint asIntegerPoint to: arrowMiddle asIntegerPoint width: w color: c.! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:12'!
visitArrowedOrthoHorizontalLineShape: anMOArrowedOrthoHorizontalLineShape
"Render an arrowed ortho horizontal line on a canvas."

	| arrowMiddle fromNode fromPoint toNode toPoint edgeBound midx w c arrowTop arrowBottom |
	"There is code duplication between this method and the display:on: in MOArrowedLineShape"
		
	w := anMOArrowedOrthoHorizontalLineShape widthFor: anElement.
	c := anMOArrowedOrthoHorizontalLineShape colorFor: anElement.

	fromNode := anElement source.
	toNode := anElement target.
	fromPoint := (fromNode bounds) rightCenter.
	toPoint := (toNode bounds) leftCenter.

"	u := self direction normal.
	arrowHead := fromPoint + (1.5@2.5).
	arrowBase := arrowHead - (self direction * self arrowSize).
	arrowMiddle := arrowHead - (0 @ (self direction y * (self arrowSize + 1))).	
	arrow := Array with: arrowHead with: arrowBase + (u * self arrowSize) with: arrowBase - (u * self arrowSize) with: arrowHead.
"
	arrowMiddle := fromPoint + (anMOArrowedOrthoHorizontalLineShape arrowSize @0).
	arrowTop := arrowMiddle - (0 @ (anMOArrowedOrthoHorizontalLineShape arrowSize)).
	arrowBottom := arrowMiddle + (0 @ (anMOArrowedOrthoHorizontalLineShape arrowSize )).
	aCanvas line: fromPoint to: arrowTop width: w color: c.
	aCanvas line: arrowTop to: arrowBottom width: w color: c.
	aCanvas line: arrowBottom to: fromPoint width: w color: c.
	
	"draw head of arrow"
"	aCanvas drawArrowHead: arrow fill: (self colorFor: aFigure) borderWidth: 1 borderColor: (self colorFor: aFigure).
"
	"draw line from element to middle of arrow head"
	edgeBound := arrowMiddle corner: toPoint.
	
	midx := (((edgeBound corner x - edgeBound origin x) / 2) + edgeBound origin x) asInteger.

	aCanvas line: arrowMiddle to: (midx @ edgeBound origin y) width: w color: c.
	aCanvas line: (midx @ edgeBound origin y) to: (midx @ edgeBound corner y) width: w color: c.
	aCanvas line: (midx @ edgeBound corner y) to: toPoint width: w color: c.


"	aCanvas 
		drawPath: (Array
			with: arrowMiddle
			with: midx @ edgeBound origin y 
			with: midx @ edgeBound corner y 
			with: toPoint)
		borderWidth: (self widthFor: aFigure) 
		borderColor: (self colorFor: aFigure).
""	aFigure display: aFigure on: aCanvas"! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:13'!
visitArrowedOrthoVerticalLineShape: anMOArrowedOrthoVerticalLineShape
	"Render an arrowed ortho vertical line on a canvas."

	| t arrowMiddle fromPoint toPoint edgeBound w c arrowTop arrowBottom midy |
	"There is code duplication between this method and the display:on: in MOArrowedLineShape"

	w := anMOArrowedOrthoVerticalLineShape widthFor: anElement.
	c := anMOArrowedOrthoVerticalLineShape colorFor: anElement.

	t := anMOArrowedOrthoVerticalLineShape getAttachPointsFor: anElement.
	fromPoint := t first.
	toPoint := t second.

	arrowMiddle := fromPoint + (0@anMOArrowedOrthoVerticalLineShape arrowSize).
	arrowTop := arrowMiddle - (anMOArrowedOrthoVerticalLineShape arrowSize@0).
	arrowBottom := arrowMiddle + (anMOArrowedOrthoVerticalLineShape arrowSize@0).
	aCanvas line: fromPoint to: arrowTop width: w color: c.
	aCanvas line: arrowTop to: arrowBottom width: w color: c.
	aCanvas line: arrowBottom to: fromPoint width: w color: c.
	
	"draw line from element to middle of arrow head"
	edgeBound := fromPoint corner: toPoint.
	midy := ((edgeBound corner y - edgeBound origin y) / 2) asInteger + edgeBound origin y.
	w := anMOArrowedOrthoVerticalLineShape widthFor: anElement.
	c := anMOArrowedOrthoVerticalLineShape colorFor: anElement.

	aCanvas line: arrowMiddle to: (edgeBound origin x @ midy) width: w color: c.
	aCanvas line: (edgeBound origin x @ midy) to: (edgeBound corner x @ midy) width: w color: c.
	aCanvas line: (edgeBound corner x @ midy) to: toPoint width: w color: c.! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:13'!
visitChildrenShape: anMOChildrenShape
"A children does not display anything so far. It is not clear whether a children shape is used as a marker or not in a forms builder"

"	self error: 'Children shape cannot display a node'."

"	| builder |
	self assert: [ anElement shape isFormsShape ].
	self assert: [ anElement shape isFormsShape ].
	builder := anElement shape builder.
	self assert: [ builder notNil ].	

	aCanvas
		translateBy: (self canvasTranslationFor: anElement)
		during: [ :tmpCanvas | anElement nodes do: [ :each | each displayOn: tmpCanvas ] ]	
"! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'AlexandreBergel 5/18/2011 13:01'!
visitCurveFitterShape: anMOCurveFitterShape
"Display a curve for the edge element on the canvas"

	| fromPoint toPoint t yUnit curve size newForm curveOrigin w |	
		
	t := anMOCurveFitterShape getAttachPointsFor: anElement.
	fromPoint := t first.
	toPoint := t second.
			
	"Check if the figure to be rendered is not too small. If this is the case, 
	then no need to draw"
	(fromPoint - toPoint) abs < (anElement threadholdSize @ anElement threadholdSize)
		ifTrue: [^ anMOCurveFitterShape ].

	curve := CurveFitter new.
	size := anMOCurveFitterShape widthFor: anElement.
	w := anMOCurveFitterShape widthFor: anElement.
	curve form: ((Form extent: w @ w depth: Display depth) fillWithColor: (anMOCurveFitterShape colorFor: anElement); yourself).
	
	"xUnit := ((toPoint - fromPoint) x / 4) asInteger."
	yUnit := ((toPoint - fromPoint) y / 3) asInteger. 

	curveOrigin := (Rectangle encompassing: {fromPoint . toPoint}) origin.
	curve firstPoint: fromPoint - curveOrigin.
	curve secondPoint: (0 @ yUnit) + fromPoint - curveOrigin.
	curve thirdPoint: toPoint - curveOrigin.
"
	curve firstPoint: 0@0.
	curve secondPoint: (0 @ yUnit).
	curve thirdPoint: toPoint - fromPoint.
"
	newForm := Form extent: ((toPoint - fromPoint) abs + (2@2)) depth: Display depth.
	curve displayOn: newForm.
	aCanvas paintImage: newForm at: curveOrigin! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:13'!
visitDashedLineShape: anMODashedLineShape
"Display a dashed line for the edge element on a canvas"

	| fromPoint toPoint t w c |	
		
	t := anMODashedLineShape getAttachPointsFor: anElement.
	fromPoint := t first.
	toPoint := t second.

	w := anMODashedLineShape widthFor: anElement.
	c := anMODashedLineShape colorFor: anElement.

	aCanvas line: fromPoint to: toPoint width: w colors: { c. anMODashedLineShape secondaryColor } dashes: anMODashedLineShape dashLengths startingOffset: 0. ! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:14'!
visitDiamondShape: anMODiamondShape
"Render a diamond for the provided node element on a canvas"

	| bounds borderWidthValue c textToDisplay font borderColorValue borderStyleValue textToDisplayBounds |
	bounds := (0@0 extent: (anMODiamondShape extentFor: anElement)). 

	c := anMODiamondShape fillColorFor: anElement.
	borderWidthValue := anMODiamondShape borderWidthFor: anElement.
	borderColorValue := anMODiamondShape borderColorFor: anElement.
	borderStyleValue := anMODiamondShape borderStyleFor: anElement.
	
	aCanvas 
		drawPolygon: { bounds topCenter. bounds rightCenter . bounds bottomCenter . bounds leftCenter } 
		color: c 
		borderWidth: borderWidthValue 
		borderColor: borderColorValue.
	
	anMODiamondShape displaySelection: anElement on: aCanvas.! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:14'!
visitEllipseShape: anMOEllipseShape
"Render an ellipse for the provided node element on a canvas"

	| bounds |
	bounds := (0@0 extent: (anMOEllipseShape extentFor: anElement)). 
	aCanvas 
		fillOval: (Rectangle
			origin: bounds origin
			extent: bounds extent)
 		fillStyle: (anMOEllipseShape fillColorFor: anElement)
		borderWidth: (anMOEllipseShape borderWidthFor: anElement)
		borderColor: (anMOEllipseShape borderColorFor: anElement).
		
	anMOEllipseShape displaySelection: anElement on: aCanvas.! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:15'!
visitFormsShape: anMOFormsShape
	| shape |
	anMOFormsShape builder shapes
		do: [ :adaptor | 
			shape := adaptor shape.
			(shape class == MOChildrenShape) ifFalse: [
				aCanvas
					translateBy: (anMOFormsShape canvasTranslationOf: shape For: anElement)
					during: [ :tmpCanvas | shape acceptVisitor: ( ConcreteShapeVisitor newElement: anElement on:tmpCanvas ). ] ] ]! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:15'!
visitImageShape: anMOImageShape
	"Render a bitmap for the provided node element on a canvas"

	| bounds |
	bounds := (0@0 extent: (anMOImageShape boundsFor: anElement) extent).

	aCanvas paintImage: (anMOImageShape form moValue: anElement)  at: bounds origin.

	anMOImageShape displaySelection: anElement on: aCanvas.! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:15'!
visitOrthoHorizontalLineShape: anMOOrthoHorizontalLineShape
	"Render an ortho horizontal line on a canvas."

	| edgeBound fromNode toNode fromPoint toPoint midx w c |
 
	fromNode := anElement source.
	toNode := anElement target.
	fromPoint := (fromNode bounds) rightCenter.
	toPoint := (toNode bounds) leftCenter.

	edgeBound := fromPoint corner: toPoint.
	
	midx := ((edgeBound corner x - edgeBound origin x) / 2) asInteger + edgeBound origin x.
	
	w := anMOOrthoHorizontalLineShape widthFor: anElement.
	c := anMOOrthoHorizontalLineShape colorFor: anElement.
	aCanvas line: fromPoint to: (midx @ edgeBound origin y) width: w color: c.
	aCanvas line: (midx @ edgeBound origin y) to: (midx @ edgeBound corner y) width: w color: c.
	aCanvas line: (midx @ edgeBound corner y) to: toPoint width: w color: c.! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:16'!
visitOrthoVerticalLineShape: anMOOrthoVerticalLineShape
	"Render an ortho vertical line on a canvas."

	| edgeBound toNode fromPoint toPoint midy w c t |

	t := anMOOrthoVerticalLineShape getAttachPointsFor: anElement.
	fromPoint := t first.
	toPoint := t second.

	edgeBound := fromPoint corner: toPoint.
	
	midy := ((edgeBound corner y - edgeBound origin y) / 2) asInteger + edgeBound origin y.
	w := anMOOrthoVerticalLineShape widthFor: anElement.
	c := anMOOrthoVerticalLineShape colorFor: anElement.

	aCanvas line: fromPoint to: (edgeBound origin x @ midy) width: w color: c.
	aCanvas line: (edgeBound origin x @ midy) to: (edgeBound corner x @ midy) width: w color: c.
	aCanvas line: (edgeBound corner x @ midy) to: toPoint width: w color: c.! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:19'!
visitRectangleShape: anMORectangleShape
"Render a rectangle for the node element provided as argument on a canvas"
	
	| bounds borderWidthValue textExtent c textToDisplay font borderColorValue borderStyleValue textToDisplayBounds textRealHeight |

	bounds := 0@0 extent: (anMORectangleShape extentFor: anElement).
	
	c := anMORectangleShape fillColorFor: anElement.
	borderWidthValue := anMORectangleShape borderWidthFor: anElement.
	borderColorValue := anMORectangleShape borderColorFor: anElement.
	borderStyleValue := anMORectangleShape borderStyleFor: anElement.

	"We render the rectangle"
	c ifNotNil: 
	[(borderWidthValue > 0)
		ifTrue: 
			[aCanvas 
				frameAndFillRectangle: bounds
					fillColor: c
					borderWidth: borderWidthValue
					borderColor: borderColorValue.
			 borderStyleValue ifNotNil:[	
				(borderStyleValue width: borderWidthValue) frameRectangle: bounds on: aCanvas 
				]]
		ifFalse:
			[aCanvas 
				frameAndFillRectangle: bounds
					fillColor: c
					borderWidth: 0
					borderColor: c ]].

	anMORectangleShape tikzText isNil ifFalse: [
		| textColor textBounds textScale |
		textScale := (anElement hasAttribute: #textScale) 
					ifTrue: [ anElement attributeAt: #textScale ]
					ifFalse: [ 1.0 ].

		font := anMORectangleShape fontFor: anElement.
		textToDisplay := anMORectangleShape textFor: anElement.
		textColor := (anMORectangleShape fontColorFor: anElement).
		textBounds := (bounds origin + (anMORectangleShape textHorizontalPadding @ anMORectangleShape textVerticalPadding)) 
							extent: (((anMORectangleShape textWidthFor: anElement) + (anMORectangleShape textHorizontalPadding)) @ 
										((anMORectangleShape textHeightFor: anElement) + (anMORectangleShape textVerticalPadding))). 
		textRealHeight := (anMORectangleShape fontSizeFor: anElement) max: ((anMORectangleShape fontFor: anElement) height) * textScale.
		textToDisplay linesDo: [ :line |
			textToDisplayBounds := (textBounds insetBy: ((anMORectangleShape borderWidthFor: anElement))).
			(anMORectangleShape textAlignment == #center) ifTrue: [
					textExtent := textToDisplayBounds extent.
					textToDisplayBounds := 
							(textBounds origin  + ((bounds width - textExtent x / 2) asInteger
											@ (bounds height - textExtent y / 2) asInteger)) extent: 
							textExtent ].
			(anMORectangleShape textAlignment == #right) ifTrue: [
					textExtent := textToDisplayBounds extent.
					textToDisplayBounds := 
							(textBounds origin  + ((bounds width - textExtent x) asInteger
											@ (bounds height - textExtent y) asInteger)) extent: 
							textExtent ].
			aCanvas 
				drawString: line
				in: textToDisplayBounds
				font:  font
				color: textColor.
			
			"We have to use a translateBy instead"
			textBounds origin: (textBounds origin + (0 @ (anMORectangleShape interlineSpace)) + 
													(0 @ (textRealHeight))). 
			textBounds corner: (textBounds corner + (0 @ (anMORectangleShape interlineSpace)) + (0 @ (textRealHeight))). 

		].
	].

	anMORectangleShape displaySelection: anElement on: aCanvas.! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:19'!
visitRoundedRectangleShape: anMORoundedRectangleShape
"Display a rounded rectangle for the provide node element on a canvas. This method is apparently buggy. The rendered rectangle is not pretty."

	| bounds borderWidthValue runningPoint increment alpha lastPoint x |
	bounds := 0@0 extent: (anMORoundedRectangleShape extentFor: anElement).

	borderWidthValue := anMORoundedRectangleShape borderWidthFor: anElement.

	aCanvas
		line: bounds origin + (anMORoundedRectangleShape radius @ 0)
		to: bounds topRight - (anMORoundedRectangleShape radius @ 0)
		width: borderWidthValue
		color: (anMORoundedRectangleShape borderColorFor: anElement).

	aCanvas
		line: bounds bottomLeft + (anMORoundedRectangleShape radius @ 0)
		to: bounds bottomRight - (anMORoundedRectangleShape radius @ 0)
		width: borderWidthValue
		color: (anMORoundedRectangleShape borderColorFor: anElement).

	aCanvas
		line: bounds origin + (0 @ anMORoundedRectangleShape radius)
		to: bounds bottomLeft - (0 @ anMORoundedRectangleShape radius)
		width: borderWidthValue
		color: (anMORoundedRectangleShape borderColorFor: anElement).

	aCanvas
		line: bounds topRight + (0 @ anMORoundedRectangleShape radius)
		to: bounds bottomRight - (0 @ anMORoundedRectangleShape radius)
		width: borderWidthValue
		color: (anMORoundedRectangleShape borderColorFor: anElement).

	runningPoint := bounds origin + (0 @ anMORoundedRectangleShape radius).
	lastPoint := runningPoint.
	0 to: anMORoundedRectangleShape radius do: [:i |
		alpha := (anMORoundedRectangleShape radius - i / anMORoundedRectangleShape radius) asFloat arcCos .
		increment := alpha sin * anMORoundedRectangleShape radius. 
		aCanvas line: runningPoint + (i@ increment negated) to: lastPoint width: (anMORoundedRectangleShape borderWidthFor: anElement) color: (anMORoundedRectangleShape borderColorFor: anElement).
		lastPoint := runningPoint + (i@ increment negated).
	].

	runningPoint := bounds topRight - (anMORoundedRectangleShape radius @ 0).
	lastPoint := runningPoint.
	0 to: anMORoundedRectangleShape radius do: [:i |
		x := (i / anMORoundedRectangleShape radius) asFloat.
		alpha :=  x arcCos .
		increment := alpha sin * anMORoundedRectangleShape radius. 
		aCanvas line: runningPoint + (i@ (anMORoundedRectangleShape radius - increment)) to: lastPoint width: (anMORoundedRectangleShape borderWidthFor: anElement) color: (anMORoundedRectangleShape borderColorFor: anElement).
		lastPoint := runningPoint + (i@ (anMORoundedRectangleShape radius - increment)).
	].

	runningPoint := bounds bottomLeft - (0 @ anMORoundedRectangleShape radius).
	lastPoint := runningPoint.
	0 to: anMORoundedRectangleShape radius do: [:i |
		x := (anMORoundedRectangleShape radius - i / anMORoundedRectangleShape radius) negated asFloat.
		alpha :=  x arcCos .
		increment := alpha sin * anMORoundedRectangleShape radius. 
		aCanvas line: runningPoint + (i@ ( increment)) to: lastPoint width: (anMORoundedRectangleShape borderWidthFor: anElement) color: (anMORoundedRectangleShape borderColorFor: anElement).
		lastPoint := runningPoint + (i@ ( increment)).
	].

	runningPoint := bounds bottomRight - (anMORoundedRectangleShape radius @ anMORoundedRectangleShape radius).
	lastPoint := bounds bottomRight - (anMORoundedRectangleShape radius @ 0).
	0 to: anMORoundedRectangleShape radius do: [:i |
		x := (i / anMORoundedRectangleShape radius) asFloat.
		alpha :=  x arcCos .
		increment := alpha sin * anMORoundedRectangleShape radius. 
		aCanvas line: runningPoint + (i@ (increment)) to: lastPoint width: (anMORoundedRectangleShape borderWidthFor: anElement) color: (anMORoundedRectangleShape borderColorFor: anElement).
		lastPoint := runningPoint + (i@ ( increment)).
	].

	anMORoundedRectangleShape displaySelection: anElement on: aCanvas.! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'AlexandreBergel 5/18/2011 13:01'!
visitSplineShape: anMOSplineShape
	"Render a spline on a canvas. It uses the class Spline for this"

	| fromPoint toPoint t spline xUnit yUnit w splineOrigin newForm encompassingRectangle |	
	t := anMOSplineShape getAttachPointsFor: anElement.
	fromPoint := t first.
	toPoint := t second.
			
	"Check if the figure to be rendered is not too small. If this is the case, 
	then no need to draw"
	(fromPoint - toPoint) abs < (anElement threadholdSize @ anElement threadholdSize)
		ifTrue: [^ anMOSplineShape ].

	spline := Spline new.
	w := anMOSplineShape widthFor: anElement.
	spline form: ((Form extent: w @ w depth: Display depth) fillWithColor: (anMOSplineShape colorFor: anElement); yourself).
	
	xUnit := ((toPoint - fromPoint) x / 4) asInteger.
	yUnit := ((toPoint - fromPoint) y / 3) asInteger. 

	encompassingRectangle := (Rectangle 
							encompassing: {	fromPoint . 
												toPoint }).
	encompassingRectangle := encompassingRectangle extendBy: (encompassingRectangle extent * 3).
	encompassingRectangle := encompassingRectangle translateBy: ( encompassingRectangle extent / 2) negated.
	
	splineOrigin := encompassingRectangle origin.

	spline add: fromPoint - splineOrigin. 
	spline add: (0 @ yUnit) + fromPoint - splineOrigin.
	spline add: ((4 * xUnit) @ ( 2 * yUnit)) + fromPoint - splineOrigin.
	spline add: toPoint - splineOrigin.
	
	spline computeCurve.
	spline isEmpty ifTrue: [ ^ anMOSplineShape ].
	newForm := Form extent: (encompassingRectangle extent + (2@2)) depth: Display depth.
	spline displayOn: newForm.
	aCanvas paintImage: newForm at: splineOrigin.
! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:21'!
visitStraightLineShape: anMOStraightLineShape
"Render a straight line on the canvas"
	
	| fromPoint toPoint t |	

	t := anMOStraightLineShape getAttachPointsFor: anElement.
	fromPoint := t first.
	toPoint := t second.

	"Check if the figure to be rendered is not too small. If this is the case, 
	then no need to draw"
	(fromPoint - toPoint) abs < (anElement threadholdSize @ anElement threadholdSize)
		ifTrue: [^ anMOStraightLineShape ].

	aCanvas 
			line: fromPoint
			to: toPoint
			width: (anMOStraightLineShape widthFor: anElement) 
			color: (anMOStraightLineShape colorFor: anElement).
		

"for anti-aliasing"
"	aCanvas 
		drawPath: (Array
			with: (fromPoint)
			with: (toPoint))
		borderWidth: (self widthFor: aFigure) 
		borderColor: (self colorFor: aFigure).
"
"	next display: anElement on: aCanvas"! !

!ConcreteShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:21'!
visitTriangleShape: anMOTriangleShape
"Render a triangle for the provide node element on a canvas"

	| bounds borderWidthValue c textToDisplay font borderColorValue borderStyleValue textToDisplayBounds |
	bounds := (0@0 extent: (anMOTriangleShape extentFor: anElement)). 

	c := anMOTriangleShape fillColorFor: anElement.
	borderWidthValue := anMOTriangleShape borderWidthFor: anElement.
	borderColorValue := anMOTriangleShape borderColorFor: anElement.
	borderStyleValue := anMOTriangleShape borderStyleFor: anElement.
	
	aCanvas 
		drawPolygon: { bounds topCenter. bounds bottomLeft . bounds bottomRight } 
		color: c 
		borderWidth: borderWidthValue 
		borderColor: borderColorValue.
		
	anMOTriangleShape displaySelection: anElement on: aCanvas.  ! !

!ShapeVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/18/2011 09:09'!
setElement: element on: canvas
	anElement:=element.
	aCanvas:=canvas.
! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:12'!
visitArrowedDashedLineShape: anMOArrowedDashedLineShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:12'!
visitArrowedLineShape: anMOArrowedLineShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:12'!
visitArrowedOrthoHorizontalLineShape: anMOArrowedOrthoHorizontalLineShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:13'!
visitArrowedOrthoVerticalLineShape: anMOArrowedOrthoVerticalLineShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:13'!
visitChildrenShape: anMOChildrenShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:13'!
visitCurveFitterShape: anMOCurveFitterShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:13'!
visitDashedLineShape: anMODashedLineShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:14'!
visitDiamondShape: anMODiamondShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:14'!
visitEllipseShape: anMOEllipseShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:15'!
visitFormsShape: anMOFormsShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:15'!
visitImageShape: anMOImageShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:15'!
visitOrthoHorizontalLineShape: anMOOrthoHorizontalLineShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:16'!
visitOrthoVerticalLineShape: anMOOrthoVerticalLineShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:19'!
visitRectangleShape: anMORectangleShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:19'!
visitRoundedRectangleShape: anMORoundedRectangleShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:20'!
visitSplineShape: anMOSplineShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:21'!
visitStraightLineShape: anMOStraightLineShape
	self subclassResponsibility! !

!ShapeVisitor methodsFor: 'visitors' stamp: 'SantiagoVidal 5/18/2011 09:21'!
visitTriangleShape: anMOTriangleShape
	self subclassResponsibility! !
